
DEFINE CLASS _SerializableObject2XML AS CUSTOM
   Name="_SerializableObject2XML"
   PROTECTED iLevel,cBadChars,iObjectList
   PROTECTED ARRAY aObjectList(1)

   iLevel=-1
   iObjectList=0

   cBadChars=""
   PROCEDURE Init
      LOCAL lcBadChars
      lcBadChars=""
      FOR lii=0 TO 8
          lcBadChars=lcBadChars+CHR(lii)
      NEXT
      FOR lii=10 TO 31
          lcBadChars=lcBadChars+CHR(lii)
      NEXT
      This.cBadChars=lcBadChars
   ENDPROC

   PROCEDURE StrTranHTMLString(lcString)
      * lcString 
      RETURN STRTRAN(STRTRAN(STRTRAN(STRTRAN(m.lcString,"&","&amp;"),">","&gt;"),"<","&lt;"),'"',"&quot;")
   ENDPROC

   PROTECTED PROCEDURE AddObject2List(loObj)
      LOCAL llExist
      llExist=PEMSTATUS(loObj,"__SerializableObjectID",5)
      IF NOT llExist
         This.iObjectList=This.iObjectList+1
         DIME This.aObjectList(This.iObjectList)
         This.aObjectList(This.iObjectList)=loObj
         =ADDPROPERTY(loObj,"__SerializableObjectID",SYS(2015))
      ENDIF
      RETURN llExist
   ENDPROC

   PROTECTED PROCEDURE FreeObjectList()
      LOCAL lii
      FOR lii=1 TO This.iObjectList
         =REMOVEPROPERTY(This.aObjectList(This.iObjectList),"__SerializableObjectID")
      NEXT
      STORE .NULL. TO This.aObjectList
      This.iObjectList=0
      DIME This.aObjectList(1)
   ENDPROC

   PROCEDURE Serializable(luValue,lcFile) && Convert object to XML
      * luValue - Object reference
      * lcFile  - Output file name
      IF EMPTY(lcFile)
         lcFile=SYS(2023)+"\"+SYS(2015)+".xml"
      ENDIF   
      _TEXT=FCREATE(lcFile,0)
      IF _TEXT<=0
         RETURN ""
      ENDIF

      TEXT TEXTMERGE NOSHOW
<?xml version="1.0" encoding="windows-<<CPCURRENT()>>" standalone="yes"?>
<result>
      ENDTEXT

      This.ToXML(luValue) && Convert object to XML

      TEXT TEXTMERGE NOSHOW 
</result>
      ENDTEXT
      =FCLOSE(_TEXT)
      _TEXT=-1
      This.FreeObjectList()
      RETURN lcFile
   ENDPROC


   PROTECTED PROCEDURE ToXML(luValue) && Convert object to XML
      * luValue - Object reference
      LOCAL lcType,lii,liy,liz,loObj,lcPom,liRows,liCols,lcpom2,lcName,lcTABs,lcValue,lcPEM,luMember,lix,llExist
      LOCAL ARRAY laMembers(1)  
      lcType=TYPE('luValue') 

      This.iLevel=This.iLevel+1
      lcTABs=SPACE(This.iLevel)

      IF lcType#'O' OR ISNULL(luValue)
         TEXT  TEXTMERGE NOSHOW
<<lcTABs>><value type="<<lcType>>"><<IIF(lcTYPE$"CM",IIF(LEN(CHRTRAN(luValue,This.cBadChars,""))=LEN(luValue), This.StrTranHTMLString(luValue),STRCONV(luValue,13)),luValue)>></value>
         ENDTEXT
         This.iLevel=This.iLevel-1
         RETURN ""
      ENDIF

      * walk member list
      lcValue='' 
      liy=AMEMBERS(laMembers,luValue) 
      FOR lii=1 TO liy
          lcPEM=laMembers(lii)

          DO CASE
             CASE lcPEM=='OBJECTS'
                  TEXT TEXTMERGE NOSHOW
<<lcTABs>><collection name="<<lcPEM>>" />
                  ENDTEXT

             CASE lcPEM=='CONTROLS'
                  TEXT TEXTMERGE NOSHOW
<<lcTABs>><collection name="<<lcPEM>>" />
                  ENDTEXT
                  FOR liz=1 TO luValue.ControlCount
                      llExist=This.AddObject2List(luValue.Controls(liz))

                      IF TYPE("luValue.Controls(liz).Name")="C"
                         TEXT TEXTMERGE NOSHOW
<<lcTABs>><object name="<<luValue.Controls(liz).Name>>">
                         ENDTEXT
                      ELSE
                         TEXT TEXTMERGE NOSHOW
<<lcTABs>><object name="">
                         ENDTEXT
                      ENDIF   
                      IF NOT llExist
                         This.ToXML(luValue.Controls(liz))
                      ELSE
                         TEXT TEXTMERGE NOSHOW 
<<lcTABs>><linkedobject name="<<luValue.Controls(liz).__SerializableObjectID>>" />
                         ENDTEXT
                      ENDIF
                      TEXT TEXTMERGE NOSHOW
<<lcTABs>></object>
                      ENDTEXT
                  NEXT

             CASE lcPEM=='PAGES'
                  TEXT TEXTMERGE NOSHOW 
<<lcTABs>><collection name="<<lcPEM>>" />
                  ENDTEXT
                  FOR liz=1 TO luValue.PageCount
                      llExist=This.AddObject2List(luValue.Pages(liz))

                      TEXT TEXTMERGE NOSHOW 
<<lcTABs>><object name="<<luValue.Pages(liz).Name>>">
                      ENDTEXT
                      IF NOT llExist
                         This.ToXML(luValue.Pages(liz))
                      ELSE
                         TEXT TEXTMERGE NOSHOW 
<<lcTABs>><linkedobject name="<<luValue.Pages(liz).__SerializableObjectID>>" />
                         ENDTEXT
                      ENDIF
                      TEXT TEXTMERGE NOSHOW 
<<lcTABs>></object>
                      ENDTEXT
                  NEXT

             CASE lcPEM=='COLUMNS'
                  TEXT TEXTMERGE NOSHOW 
<<lcTABs>><collection name="<<lcPEM>>" />
                  ENDTEXT
                  FOR liz=1 TO luValue.ColumnCount
                      llExist=This.AddObject2List(luValue.Columns(liz))

                      TEXT TEXTMERGE NOSHOW 
<<lcTABs>><object name="<<luValue.Columns(liz).Name>>">
                      ENDTEXT
                      IF NOT llExist
                         This.ToXML(luValue.Columns(liz))
                      ELSE
                         TEXT TEXTMERGE NOSHOW 
<<lcTABs>><linkedobject name="<<luValue.Columns(liz).__SerializableObjectID>>" />
                         ENDTEXT
                      ENDIF
                         
                      TEXT TEXTMERGE NOSHOW 
<<lcTABs>></object>
                      ENDTEXT
                  NEXT


             CASE lcPEM=='ACTIVEFORM' OR lcPEM=='ACTIVECONTROL' OR lcPEM=='PARENT'
                  TEXT TEXTMERGE NOSHOW 
<<lcTABs>><object name="<<lcPEM>>"><<IIF(TYPE('luValue.'+lcPEM)<>'O','',EVAL('luValue.'+lcPEM+'.Name'))>></object>
                  ENDTEXT

             CASE TYPE("luValue."+lcPEM,1)="A"
                  lcPom='luValue.'+lcPEM
                  liRows=EVAL("ALEN("+lcPom+",1)")
                  liCols=EVAL("ALEN("+lcPom+",2)")
                  IF liCols>0
                     TEXT TEXTMERGE NOSHOW 
<<lcTABs>><array name="<<lcPEM>>" rows="<<liRows>>" cols="<<liCols>>">
                     ENDTEXT
                  ELSE
                     TEXT TEXTMERGE NOSHOW 
<<lcTABs>><array name="<<lcPEM>>" rows="<<liRows>>">
                     ENDTEXT
                  ENDIF

                  * walk cells
                  FOR liz=1 TO EVAL("ALEN("+lcPom+")")
                      IF liCols>0
                         liRow=INT((liz-1)/liCols)+1
                         liCol=liz-((liRow-1)*liCols)
                         
                         TEXT TEXTMERGE NOSHOW 
<<lcTABs>><cell row="<<liRow>>" col="<<liCol>>">
                         ENDTEXT
                      ELSE
                         TEXT TEXTMERGE NOSHOW 
<<lcTABs>><cell row="<<liz>>">
                         ENDTEXT
                      ENDIF   
                      This.ToXML(EVAL(lcPom+"(liz)"))
                      TEXT TEXTMERGE NOSHOW
<<lcTABs>></cell>
                      ENDTEXT
                  NEXT
                                    
                  TEXT TEXTMERGE NOSHOW
<<lcTABs>></array>
                  ENDTEXT

             CASE lcPEM=='LIST'
                  lcPom='luValue.'+lcPEM
                  liRows=luValue.ListCount
                  liCols=luValue.ColumnCount
                  TEXT TEXTMERGE NOSHOW 
<<lcTABs>><list rows="<<liRows>>" cols="<<liCols>>">
                  ENDTEXT

                  FOR liRow=1 TO liRows

                      TEXT TEXTMERGE NOSHOW 
<<lcTABs>><listrow row="<<liRow>>">
                      ENDTEXT
                      FOR liCol=1 TO liCols
                          TEXT TEXTMERGE NOSHOW 
<<lcTABs>><listcol col="<<liCol>>">
                          ENDTEXT
 
                          This.ToXML(luValue.List(liRow,liCol))
                          TEXT TEXTMERGE NOSHOW
<<lcTABs>></listcol>
                          ENDTEXT
                      NEXT   

                      TEXT TEXTMERGE NOSHOW
<<lcTABs>></listrow>
                      ENDTEXT
                  NEXT
                                    
                  TEXT TEXTMERGE NOSHOW
<<lcTABs>></list>
                  ENDTEXT
   

             CASE TYPE('luValue.'+lcPEM)='O'
                  loObj=EVAL("luValue."+lcPEM)
                  TEXT TEXTMERGE NOSHOW 
<<lcTABs>><object name="<<lcPEM>>">
                  ENDTEXT

                  IF !ISNULL(loObj)  && pokud ona vlastnost je nenulov
                     llExist=This.AddObject2List(loObj)
                     IF NOT llExist
                        * pak pidej nzae nalinkovanho objektu
                        This.ToXML(loObj)
                     ELSE
                        TEXT TEXTMERGE NOSHOW 
<<lcTABs>><linkedobject name="<<loObj.__SerializableObjectID>>" />
                        ENDTEXT
                     ENDIF
                  ENDIF   
                  TEXT TEXTMERGE NOSHOW 
<<lcTABs>></object>
                  ENDTEXT

             OTHERWISE

                  lcType=TYPE('EVAL("luValue."+lcPEM)')
                  DO CASE
                     CASE lcType==""
                          lcPom= This.StrTranHTMLString("Damaged property")
                          TEXT TEXTMERGE NOSHOW
<<lcTABs>><value type="<<lcType>>" name="<<lcPEM>>"><<lcPom>></value>
                          ENDTEXT
                          
                     CASE lcType="U"
                          lcPom= This.StrTranHTMLString("Hidden or Protected property")
                          TEXT TEXTMERGE NOSHOW
<<lcTABs>><value type="<<lcType>>" name="<<lcPEM>>"><<lcPom>></value>
                          ENDTEXT
                     
                     OTHERWISE
                          luMember=EVAL("luValue."+lcPEM)

                          TEXT TEXTMERGE NOSHOW 
<<lcTABs>><value type="<<lcType>>" name="<<lcPEM>>"><<IIF(lcType$"CM",IIF(LEN(CHRTRAN(luMember,This.cBadChars,""))=LEN(luMember), This.StrTranHTMLString(luMember),STRCONV(luMember,13)),luMember)>></value>
                          ENDTEXT
                  ENDCASE
          ENDCASE

      NEXT
      This.iLevel=This.iLevel-1
      RETURN ""
   ENDPROC

ENDDEFINE
